<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class ATACode
{
	protected $ci;
	private $code = '';
	private $materia = array();
	private $tema = array();
	private $subtemas = array();
	private $fecha = '';
	private $consulta = '';
	private $shortcode = FALSE;

	public function __construct()
	{
		$this->ci =& get_instance();
		$this->ci->load->model('contenido_model');
	}

	public function code($code = NULL)
	{
		if (is_null($code)) {
			return $this->make_code();
		} else {
			return $this->parse_code($code);
		}
	}

	function make_code()
	{
		
	}

	private function initialize()
	{
		$this->code = '';
		$this->materia = array();
		$this->tema = array();
		$this->subtemas = array();
		$this->fecha = '';
		$this->consulta = '';
		$this->shortcode = FALSE;
	}

	function code_debug(){
		return array(
			'materia' => $this->materia,
			'tema' => $this->tema,
			'subtemas' => $this->subtemas
			);
	}

	function parse_code($code, $shortcode = FALSE){ // Jurisprudencia usa codigo short (sin subtema)
		
		if($code !== $this->code){
			$this->initialize();
			$remove_slash = explode('/', $code);
			
			if(sizeof($remove_slash) === 2){
				$remove_dash = explode('-', $remove_slash[1]);
				
				if(sizeof($remove_dash) >= 2){
					$this->materia['codigo'] = $remove_slash[0];
					$this->tema['codigo'] = $remove_dash[0];
					$subtemas = array_slice($remove_dash, 1);
					if (sizeof($subtemas)) {
						foreach ($subtemas as $subtema) {
							$this->subtemas[]['codigo'] = $subtema;
						}
					} else{
						throw new UnexpectedValueException("El código proporcionado no cumple con el formato", 1);
					}
				} else {
					if($shortcode){
						$this->materia['codigo'] = $remove_slash[0];
						$this->tema['codigo'] = $remove_dash[0];
						$this->subtemas[]['codigo'] = 1;
						$this->shortcode = $shortcode;
						//return $this;
					} else {
						throw new UnexpectedValueException("El código proporcionado no cumple con el formato", 1);
					}
				}
			} else {
				throw new UnexpectedValueException("El código proporcionado no cumple con el formato", 1);
			}
			
			$this->ci->contenido_model->codigo_a_ids($this);
		}
		return $this;
	}

	public function isShortCode() {
		return $this->shortcode;
	}

	public function getMateria() {
		return $this->materia;
	}
	
	public function setMateria($materia) {
		$this->materia = $materia;
		return $this;
	}

	public function getTema() {
		return $this->tema;
	}

	public function setTema($tema) {
		$this->tema = $tema;
		return $this;
	}

	public function getSubtemas($get_first = FALSE) {
		if ($get_first) {
			return $this->subtemas[0];
		} else {
			return $this->subtemas;
		}
	}
	
	public function setSubtemas($subtemas) {
		if (is_array($subtemas)) {
			$this->subtemas = $subtemas;
		} else {
			array_push($this->subtemas, $subtemas);
		}
	    return $this;
	}

	public function getFecha() {
	    return $this->fecha;
	}

	public function setFecha($fecha) {
	    $this->fecha = $fecha;
	    return $this;
	}

	public function getConsulta() {
	    return $this->consulta;
	}

	public function setConsulta($consulta) {
	    $this->consulta = $consulta;
	    return $this;
	}


}

/* End of file libraryName.php */
/* Location: ./application/libraries/libraryName.php */
